import traceback

from cpl_core.configuration.configuration_model_abc import ConfigurationModelABC
from cpl_core.console import Console


class TestSettings(ConfigurationModelABC):

    def __init__(self):
        ConfigurationModelABC.__init__(self)

        self._login_url = ''
        self._me_page_url = ''
        self._cmd_url = ''
        self._guild_id = 0
        self._bot_id = 0
        self._test_user_id = 0

    @property
    def login_url(self) -> str:
        return self._login_url

    @property
    def me_page_url(self) -> str:
        return self._me_page_url

    @property
    def cmd_url(self) -> str:
        return self._cmd_url

    @property
    def guild_id(self) -> int:
        return self._guild_id

    @property
    def bot_id(self) -> int:
        return self._bot_id

    @property
    def test_user_id(self) -> int:
        return self._test_user_id

    def from_dict(self, settings: dict):
        try:
            self._login_url = settings['LoginUrl']
            self._me_page_url = settings['MePageUrl']
            self._cmd_url = settings['CmdURL']
            self._guild_id = settings['GuildId']
            self._bot_id = settings['BotId']
            self._test_user_id = settings['TestUserId']
        except Exception as e:
            Console.error(f'[ ERROR ] [ {__name__} ]: Reading error in {type(self).__name__} settings')
            Console.error(f'[ EXCEPTION ] [ {__name__} ]: {e} -> {traceback.format_exc()}')
