import discord

from ui_tests.src.ui_tests_shared.command_selectors_enum import CommandSelectorsEnum
from ui_tests_shared.command_test_case_with_app import CommandTestCaseWithApp
from ui_tests_shared.decorators import Async


class HelpCommandTestCase(CommandTestCaseWithApp):

    @Async.async_func
    async def test_help(self):
        correct_response = 'https://git.sh-edraft.de/sh-edraft.de/kd_discord_bot/wiki/Befehle'
        self.send_command('help', CommandSelectorsEnum.help)

        def check(m: discord.Message):
            return m.content == correct_response and m.author.id == self._test_settings.bot_id

        response = await self._bot.wait_for('message', check=check)
        self.assertEqual(response.content, correct_response)
        await self._bot.close()
