import asyncio
import time

import discord

from ui_tests.src.ui_tests_shared.command_selectors_enum import CommandSelectorsEnum
from ui_tests_shared.command_test_case_with_app import CommandTestCaseWithApp
from ui_tests_shared.decorators import Async


class PurgeCommandTestCase(CommandTestCaseWithApp):

    def setUp(self):
        self.send_message('test nachricht 1')
        self.send_message('test nachricht 2')
        self.send_message('test nachricht 3')
        self.send_message('test nachricht 4')

    def test_purge(self):
        correct_response = self._t.transform('modules.moderator.purge_message')
        self.assertIsNotNone(correct_response)
        self.send_command('purge', CommandSelectorsEnum.purge)

        def check(m: discord.Message):
            return m.content == correct_response and m.author.id == self._test_settings.bot_id

        response = asyncio.run(self._bot.wait_for('message', check=check))
        self.assertEqual(response.content, correct_response)
        time.sleep(20)
        channel = self._bot.get_channel(911578680998895687)
        self.assertEqual(channel.message_count, 0)
